/* Automatically generated from ../../src/org.woodchuck.manager.xml. */
#define ORG_WOODCHUCK_MANAGER_XML "  <interface name=\"org.woodchuck.manager\">\n" \
"    <!-- Unregister this manager and any descendent objects.  This\n" \
"         does not remove any files; only the metadata stored on the\n" \
"         Woodchuck server is deleted.  -->\n" \
"    <method name=\"Unregister\">\n" \
"      <!-- If true, fail if this manager has any descendents.  -->\n" \
"      <arg name=\"OnlyIfNoDescendents\" type=\"b\"/>\n" \
"    </method>\n" \
"\n" \
"    <!-- Register a new manager, which is subordinate to this one.\n" \
"\n" \
"         This enables the creation of a manager hierarchy, which is\n" \
"         useful for separating a program's components.  For instance,\n" \
"         a web browser might have a page cache and a set of files that\n" \
"         should be downloaded later.  Each should be registered as a\n" \
"         child manager to the top-level web browser manager.  -->\n" \
"    <method name=\"ManagerRegister\">\n" \
"      <!-- Dictionary of initial values for the various\n" \
"           properties.\n" \
"\n" \
"           The following properties are required: `HumanReadableName`.\n" \
"\n" \
"           Note: The a{ss} type is also supported, but then only\n" \
"           properties with a string type may be expressed.  (This is a\n" \
"           concession to dbus-send, as it does not support parameters\n" \
"           with the variant type.)\n" \
"      -->\n" \
"      <arg name=\"Properties\" type=\"a{sv}\"/>\n" \
"\n" \
"      <!-- Only succeed if the supplied cookie is unique among all\n" \
"           sibling managers.  -->\n" \
"      <arg name=\"OnlyIfCookieUnique\" type=\"b\"/>\n" \
"\n" \
"      <!-- The new manager's unique identifier (a 16-character\n" \
"           alpha-numeric string).  -->\n" \
"      <arg name=\"UUID\" type=\"s\" direction=\"out\"/>\n" \
"    </method>\n" \
"\n" \
"    <!-- Return a list of child managers.  -->\n" \
"    <method name=\"ListManagers\">\n" \
"      <!-- Whether to list all descendents (true) or just immediate\n" \
"           children (false).  -->\n" \
"      <arg name=\"Recursive\" type=\"b\"/>\n" \
"\n" \
"      <!-- An array of <`UUID`, `Cookie`, `HumanReadableName`,\n" \
"           `ParentUUID`>.  -->\n" \
"      <arg name=\"Managers\" type=\"a(ssss)\" direction=\"out\"/>\n" \
"    </method>\n" \
"\n" \
"    <!-- Return the managers whose `Cookie` property matches the\n" \
"         specified cookie.  -->\n" \
"    <method name=\"LookupManagerByCookie\">\n" \
"      <!-- The cookie to match.  -->\n" \
"      <arg name=\"Cookie\" type=\"s\"/>\n" \
"      <!-- If true, consider any descendent manager.  If false, only\n" \
"           consider immediate children.  -->\n" \
"      <arg name=\"Recursive\" type=\"b\"/>\n" \
"\n" \
"      <!-- An array of <`UUID`, `HumanReadableName`, `ParentUUID`>.  -->\n" \
"      <arg name=\"Managers\" type=\"a(sss)\" direction=\"out\"/>\n" \
"    </method>\n" \
"\n" \
"    <!-- Register a new stream.  -->\n" \
"    <method name=\"StreamRegister\">\n" \
"      <!-- Dictionary of initial values for the various\n" \
"           properties. See the :class:`org.woodchuck.stream`\n" \
"           interface for the list of properties and their meanings.\n" \
"\n" \
"           The following properties are required: `HumanReadableName`\n" \
"\n" \
"           Note: The a{ss} type is also supported, but then only\n" \
"           properties with a string type may be expressed.  (This is a\n" \
"           concession to dbus-send, as it does not support parameters\n" \
"           with the variant type.)  -->\n" \
"      <arg name=\"Properties\" type=\"a{sv}\"/>\n" \
"\n" \
"      <!-- Only succeed if the supplied cookie is unique among all\n" \
"           streams belonging to this manager.  -->\n" \
"      <arg name=\"OnlyIfCookieUnique\" type=\"b\"/>\n" \
"\n" \
"      <!-- The new stream's unique identifier.  -->\n" \
"      <arg name=\"UUID\" type=\"s\" direction=\"out\"/>\n" \
"    </method>\n" \
"\n" \
"    <!-- Return a list of streams.  -->\n" \
"    <method name=\"ListStreams\">\n" \
"      <!-- An array of <`UUID`, `Cookie`, `HumanReadableName`>.  -->\n" \
"      <arg name=\"Streams\" type=\"a(sss)\" direction=\"out\"/>\n" \
"    </method>\n" \
"\n" \
"    <!-- Return a list of streams with the specified cookie.  -->\n" \
"    <method name=\"LookupStreamByCookie\">\n" \
"      <!-- The cookie to match.  -->\n" \
"      <arg name=\"Cookie\" type=\"s\"/>\n" \
"\n" \
"      <!-- An array of <`UUID`, `HumanReadableName`>.  -->\n" \
"      <arg name=\"Streams\" type=\"a(ss)\" direction=\"out\"/>\n" \
"    </method>\n" \
"\n" \
"    <!-- Indicate that the calling process would like to receive\n" \
"         upcalls pertaining to this manager and (optionally) any of\n" \
"         its descendents.\n" \
"\n" \
"         .. Note: Upcalls are sent to all subscriptions.  Thus, if a\n" \
"             single process has multiple subscriptions, it will receive\n" \
"             the same upcall multiple times.\n" \
"\n" \
"         Feedback is sent until :func:`FeedbackUnsubscribe` is called.\n" \
"\n" \
"         .. Note: If the calling process's private DBus name becomes\n" \
"             invalid, the subscription is automatically cancelled.\n" \
"         -->\n" \
"    <method name=\"FeedbackSubscribe\">\n" \
"      <!-- If true, also make upcalls for any descendents.  -->\n" \
"      <arg name=\"DescendentsToo\" type=\"b\"/>\n" \
"\n" \
"      <!-- An opaque handle, that must be passed to\n" \
"           :func:`FeedbackUnSubscribe`.  -->\n" \
"      <arg name=\"Handle\" type=\"s\" direction=\"out\"/>\n" \
"    </method>\n" \
"\n" \
"    <!-- Request that Woodchuck cancel the indicated subscription.\n" \
"         -->\n" \
"    <method name=\"FeedbackUnsubscribe\">\n" \
"      <!-- The handle returned by :func:`FeedbackSubscribe`.  -->\n" \
"      <arg name=\"Handle\" type=\"s\"/>\n" \
"    </method>\n" \
"\n" \
"    <!-- Ack the feedback with the provided UUID.  -->\n" \
"    <method name=\"FeedbackAck\">\n" \
"      <arg name=\"ObjectUUID\" type=\"s\"/>\n" \
"      <arg name=\"ObjectInstance\" type=\"u\"/>\n" \
"    </method>\n" \
"\n" \
"    <!-- This manager's parent manager.  -->\n" \
"    <property name=\"ParentUUID\" type=\"s\" access=\"read\"/>\n" \
"\n" \
"    <!-- A human readable name for the manager.  When displaying a\n" \
"         manager's human readable name, the human readable name of\n" \
"         each of its ancestors as well as its own will be concatenated\n" \
"         together.  Thus, if the manager's parent is called \"Firefox\"\n" \
"         and it has a child web cache, the human readable name of the\n" \
"         child should be \"Web Cache,\" not \"Firefox Web Cache.\"  The\n" \
"         latter would result in \"Firefox Firefox Web Cache\" being\n" \
"         displayed to the user.  -->\n" \
"    <property name=\"HumanReadableName\" type=\"s\" access=\"readwrite\"/>\n" \
"\n" \
"    <!-- A free-form string uninterpreted by the server and passed to\n" \
"         any manager upcalls.\n" \
"\n" \
"         By convention, this is set to the application's DBus name\n" \
"         thereby allowing all application's to easily lookup the UUID\n" \
"         of their manager and avoiding any namespace collisions.\n" \
"\n" \
"         .. Note: Woodchuck does not enforce that the `Cookie`\n" \
"             property be unique.  -->\n" \
"    <property name=\"Cookie\" type=\"s\" access=\"readwrite\"/>\n" \
"\n" \
"    <!-- The DBus service name of the service to start when there is\n" \
"         work to do, e.g., streams to update or objects to transfer.\n" \
"         See :class:`org.woodchuck.upcall`.  -->\n" \
"    <property name=\"DBusServiceName\" type=\"s\" access=\"readwrite\"/>\n" \
"\n" \
"    <!-- The DBus object to send upcalls to.  This defaults to\n" \
"         '/org/woodchuck'.  -->\n" \
"    <property name=\"DBusObject\" type=\"s\" access=\"readwrite\"/>\n" \
"\n" \
"    <!-- The priority, relative to other managers with the same parent\n" \
"         manager.  -->\n" \
"    <property name=\"Priority\" type=\"u\" access=\"readwrite\"/>\n" \
"\n" \
"    <!-- Whether the manager is enabled.  If a manager is disabled,\n" \
"         any streams or objects managed by it (or any descendents)\n" \
"         will be updated or transferred, respectively.  -->\n" \
"    <property name=\"Enabled\" type=\"b\" access=\"readwrite\"/>\n" \
"\n" \
"    <!-- The time at which the object was registered.  -->\n" \
"    <property name=\"RegistrationTime\" type=\"t\" access=\"read\"/>\n" \
"  </interface>\n"
