/* Automatically generated from ../../src/org.woodchuck.object.xml. */
#define ORG_WOODCHUCK_OBJECT_XML "  <interface name=\"org.woodchuck.object\">\n" \
"    <!-- Unregister this object.  This does not remove any files, only\n" \
"         metadata stored on the Woodchuck server is deleted.  -->\n" \
"    <method name=\"Unregister\">\n" \
"    </method>\n" \
"\n" \
"\n" \
"    <!-- This object is needed, e.g., the user just select an email to\n" \
"         read.\n" \
"\n" \
"         This method is only useful for object's that make use of\n" \
"         Woodchuck's simple transferer.  See\n" \
"         :data:`org.woodchuck.object.Versions` for more information.\n" \
"    -->\n" \
"    <method name=\"Transfer\">\n" \
"      <!-- The type of request.\n" \
"\n" \
"	   * 1 - User initiated\n" \
"	   * 2 - Application initiated\n" \
"      -->\n" \
"      <arg name=\"RequestType\" type=\"u\"/>\n" \
"    </method>\n" \
"\n" \
"\n" \
"    <!-- Indicate that an object has been transferred.\n" \
"\n" \
"         This is typically called in reaction to a\n" \
"         :func:`org.woodchuck.upcall.ObjectTransfer` upcall, but\n" \
"         should whenever an object is transferred.\n" \
"\n" \
"         The value of the object's :data:`Instance` property will be\n" \
"         incremented by 1.\n" \
"         -->\n" \
"    <method name=\"TransferStatus\">\n" \
"      <!-- 0: Success.\n" \
"\n" \
"           Transient errors (will try again later):\n" \
"\n" \
"           * 0x100: Other.\n" \
"           * 0x101: Unable to contact server.\n" \
"           * 0x102: Transfer incomplete.\n" \
"\n" \
"           Hard errors (give up trying to transfer this object):\n" \
"\n" \
"	   * 0x200: Other.\n" \
"           * 0x201: File gone.\n" \
"      -->\n" \
"      <arg name=\"Status\" type=\"u\"/>\n" \
"\n" \
"      <!-- The type of indicator displayed to the user, if any.  A\n" \
"           bitmask of:\n" \
"\n" \
"             * 0x1: Audio sound\n" \
"	     * 0x2: Application visual notification\n" \
"	     * 0x4: Desktop visual notification, small, e.g., blinking icon\n" \
"	     * 0x8: Desktop visual notification, large, e.g., system tray\n" \
"	       notification\n" \
"	     * 0x10: External visible notification, e.g., an LED\n" \
"	     * 0x20: Vibrate\n" \
"\n" \
"             * 0x40: Object-specific notification\n" \
"             * 0x80: Stream-wide notification, i.e., an aggregate\n" \
"	       notification for all updates in the stream.\n" \
"             * 0x100: Manager-wide notification, i.e., an aggregate\n" \
"	       notification for all updates in the manager.\n" \
"\n" \
"             * 0x80000000: It is unknown if an indicator was shown.\n" \
"\n" \
"           0 means that no notification was shown.  -->\n" \
"      <arg name=\"Indicator\" type=\"u\"/>\n" \
"\n" \
"      <!-- The approximate number of bytes uploaded.  (Pass -1 if\n" \
"           unknown.)  -->\n" \
"      <arg name=\"TransferredUp\" type=\"t\"/>\n" \
"      <!-- The approximate number of bytes downloaded.  (Pass -1 if\n" \
"           unknown.)  -->\n" \
"      <arg name=\"TransferredDown\" type=\"t\"/>\n" \
"\n" \
"      <!-- The time at which the transfer was started (in seconds\n" \
"           since the epoch).  Pass 0 if unknown. -->\n" \
"      <arg name=\"TransferTime\" type=\"t\"/>\n" \
"      <!-- The time, in seconds, it took to perform the transfer.\n" \
"           Pass 0 if unknown.  -->\n" \
"      <arg name=\"TransferDuration\" type=\"u\"/>\n" \
"\n" \
"      <!-- The size of the object on disk (in bytes).  Pass -1 if\n" \
"           unknown.  -->\n" \
"      <arg name=\"ObjectSize\" type=\"t\"/>\n" \
"\n" \
"      <!-- An array of <`Filename`, `Dedicated`, `DeletionPolicy`>\n" \
"           tuples.\n" \
"\n" \
"           `Filename` is the absolute filename of a file that contains\n" \
"           data from this object.\n" \
"\n" \
"	   `Dedicated` indicates whether `Filename` is dedicated to\n" \
"	   that object (true) or whether it includes other state\n" \
"	   (false).\n" \
"\n" \
"           `DeletionPolicy` indicates if the file is precious and may\n" \
"           only be deleted by the user (0), if the file may be deleted\n" \
"           by woodchuck without consulting the application (1), or if\n" \
"           the application is willing to delete the file (via\n" \
"           :func:`org.woodchuck.upcall.ObjectDeleteFiles`) (2).  -->\n" \
"      <arg name=\"Files\" type=\"a(sbu)\"/>\n" \
"    </method>\n" \
"\n" \
"    <method name=\"Used\">\n" \
"      <!-- When the user started using the object.  -->\n" \
"      <arg name=\"Start\" type=\"t\"/>\n" \
"      <!-- How long the user used the object.  -1 means unknown.  0\n" \
"           means instantaneous.  -->\n" \
"      <arg name=\"Duration\" type=\"t\"/>\n" \
"\n" \
"      <!-- Bit mask indicating which portions of the object were used.\n" \
"           Bit 0 corresponds to the first 1/64 of the object, bit 1 to\n" \
"           the second 1/64 of the object, etc.  -->\n" \
"      <arg name=\"UseMask\" type=\"t\"/>\n" \
"    </method>\n" \
"\n" \
"    <!-- Call when an objects files have been removed or in response\n" \
"	 to org.woodchuck.upcall.ObjectDelete.  -->\n" \
"    <method name=\"FilesDeleted\">\n" \
"      <!-- Taken from enum woodchuck_delete_response (see\n" \
"           <woodchuck/woodchuck.h>):\n" \
"\n" \
"           * 0: Files deleted.  ARG is ignored.\n" \
"	   * 1: Deletion refused.  Preserve for at least ARG\n" \
"	     seconds before asking again.\n" \
"	   * 2: Files compressed.  ARG is the new size in bytes.\n" \
"	     (-1 = unknown.)\n" \
"      -->\n" \
"      <arg name=\"Update\" type=\"u\"/>\n" \
"\n" \
"      <arg name=\"Arg\" type=\"t\"/>\n" \
"    </method>\n" \
"\n" \
"    <!-- The stream this object belongs to.  -->\n" \
"    <property name=\"ParentUUID\" type=\"s\" access=\"read\"/>\n" \
"\n" \
"    <!-- The number of times this object has been transferred.  -->\n" \
"    <property name=\"Instance\" type=\"u\" access=\"read\"/>\n" \
"\n" \
"    <!-- A human readable name.  -->\n" \
"    <property name=\"HumanReadableName\" type=\"s\" access=\"readwrite\"/>\n" \
"\n" \
"    <!-- Uninterpretted by Woodchuck.  This is passed in any\n" \
"         object upcalls.\n" \
"\n" \
"         The application can set this to a database key or URL to\n" \
"         avoid having to manage a mapping between Woodchuck UUIDs and\n" \
"         local identifiers.  -->\n" \
"    <property name=\"Cookie\" type=\"s\" access=\"readwrite\"/>\n" \
"\n" \
"    <!-- An array of <`URL`, `ExpectedSize`, `ExpectedTransferUp`,\n" \
"         `ExpectedTransferDown`, `Utility`, `UseSimpleTransferer`>\n" \
"         tuples.  Each tuple designates the same object, but with a\n" \
"         different quality.\n" \
"\n" \
"	 `URL` is optional.  Its value is only interpretted by\n" \
"	 Woodchuck if `UseSimpleTransferer` is also true.\n" \
"\n" \
"         `ExpectedSize` is the expected amount of disk space required\n" \
"         when this transfer completes.  If this is negative, this\n" \
"         indicates that transferring this objects frees space.\n" \
"\n" \
"         `ExpectedTransferUp` is the expected upload size, in bytes.\n" \
"\n" \
"         `ExpectedTransferDown` is the expected download size, in\n" \
"         bytes.\n" \
"\n" \
"         `Utility` is the utility of this version of the object\n" \
"         relative to other versions of this object.  Woodchuck\n" \
"         interprets the value linearly: a version with twice the\n" \
"         utility is consider to offer twice the quality.  If bandwidth\n" \
"         is scarce but the object is considered to have a high\n" \
"         utility, a lower quality version may be transferred.  If a\n" \
"         version has no utility, then it shouldn't be listed here.\n" \
"\n" \
"         `UseSimpleTransferer` specifies whether to use Woodchuck's\n" \
"         built in simple transferer for transferring this object.  When\n" \
"         Woodchuck has transferred an object, it will invoke the\n" \
"         :func:`org.woodchuck.upcall.ObjectTransferred` upcall.\n" \
"\n" \
"         If `UseSimpleTransferer` is false, Woodchuck will make the\n" \
"         :func:`org.woodchuck.upcall.ObjectTransfer` upcall to the\n" \
"         application when the application should transfer the object.\n" \
"         Woodchuck also specified which version of the object to\n" \
"         transfer.\n" \
"    -->\n" \
"    <property name=\"Versions\" type=\"a(sxttub)\" access=\"readwrite\"/>\n" \
"\n" \
"    <!-- Where to save the file(s).  If FILENAME ends in a /,\n" \
"         interpreted as a directory and the file is named after the\n" \
"         URL.  -->\n" \
"    <property name=\"Filename\" type=\"s\" access=\"readwrite\"/>\n" \
"\n" \
"    <!-- Whether to wake the application when this job completes\n" \
"         (i.e., by sending a dbus message) or to wait until a process\n" \
"         subscribes to feedback (see\n" \
"         :func:`org.woodchuck.manager.FeedbackSubscribe`).  This is\n" \
"         only meaningful if the Woodchuck server transfers the file\n" \
"         (i.e., `UseSimpleTransferer` is true).\n" \
"         -->\n" \
"    <property name=\"Wakeup\" type=\"b\" access=\"readwrite\"/>\n" \
"\n" \
"    <!-- Approximately when the transfer should be performed, in\n" \
"         seconds since the epoch.  (If the property Period is not\n" \
"         zero, automatically updated after each transfer.)\n" \
"\n" \
"         The special value 0 means at the next available opportunity.\n" \
"         -->\n" \
"    <property name=\"TriggerTarget\" type=\"t\" access=\"readwrite\"/>\n" \
"    <!-- The earliest time the transfer may occur.  Seconds prior to\n" \
"         TriggerTarget.  -->\n" \
"    <property name=\"TriggerEarliest\" type=\"t\" access=\"readwrite\"/>\n" \
"    <!-- The latest time the transfer may occur.  After this time, the\n" \
"         transfer will be reported as having failed.\n" \
"         \n" \
"         Seconds after TriggerTarget.  -->\n" \
"    <property name=\"TriggerLatest\" type=\"t\" access=\"readwrite\"/>\n" \
"\n" \
"    <!-- The period (in seconds) with which to repeat this transfer.\n" \
"         Set to 0 to indicate that this is a one-shot transfer.  This\n" \
"         is useful for an object which is updated periodically, e.g.,\n" \
"         the weather report.  You should not use this for a\n" \
"         self-contained stream such as a blog.  Instead, on\n" \
"         transferring the feed, register each contained story as an\n" \
"         individual object and mark it as transferred immediately.\n" \
"         Default: 0.  -->\n" \
"    <property name=\"TransferFrequency\" type=\"u\" access=\"readwrite\"/>\n" \
"\n" \
"    <!-- Set to true if this object should not be transferred, e.g.,\n" \
"         because the application knows the user has no interest in it.  -->\n" \
"    <property name=\"DontTransfer\" type=\"b\" access=\"readwrite\"/>\n" \
"\n" \
"    <!-- Set to true if an update for this object is available.  This\n" \
"         is automatically cleared by TransferStatus.  -->\n" \
"    <property name=\"NeedUpdate\" type=\"b\" access=\"readwrite\"/>\n" \
"\n" \
"    <!-- The priority, relative to other objects in the stream.  -->\n" \
"    <property name=\"Priority\" type=\"u\" access=\"readwrite\"/>\n" \
"\n" \
"    <!-- The time at which the object was discovered (in seconds since\n" \
"         the epoch).  This is normally the time at which the stream\n" \
"         was updated.  -->\n" \
"    <property name=\"DiscoveryTime\" type=\"t\" access=\"readwrite\"/>\n" \
"\n" \
"    <!-- The time at which the object was published (in seconds since\n" \
"         the epoch).  -->\n" \
"    <property name=\"PublicationTime\" type=\"t\" access=\"readwrite\"/>\n" \
"\n" \
"    <!-- The time at which the object was registered.  -->\n" \
"    <property name=\"RegistrationTime\" type=\"t\" access=\"read\"/>\n" \
"\n" \
"    <!-- The time at which the object was last successfully\n" \
"         transferred. -->\n" \
"    <property name=\"LastTransferTime\" type=\"t\" access=\"read\"/>\n" \
"\n" \
"    <!-- The time at which the last transfer attempt occured .  -->\n" \
"    <property name=\"LastTransferAttemptTime\" type=\"t\" access=\"read\"/>\n" \
"\n" \
"    <!-- The status code of the last transfer attempt .  -->\n" \
"    <property name=\"LastTransferAttemptStatus\" type=\"u\" access=\"read\"/>\n" \
"  </interface>\n"
